function COMPLEX_adm(action)

switch action
    
case 'f(z)'
    
    h=findobj(gcbf,'Tag','f(z)');
    fz=get(h,'String');
    hz=findobj(gcbf,'Tag','z');
    hw=findobj(gcbf,'Tag','w');
    XLim=get(hz,'XLim');
    YLim=get(hz,'YLim');
    x=XLim(1):diff(XLim)/20:XLim(2);
    y=YLim(1):diff(YLim)/20:YLim(2);
    [X,Y]=meshgrid(x,y);
    axes(hz)
    cla
    axis equal
    for i=1:size(X,1)
       line(x,Y(i,:))
    end
    for j=1:size(X,2)
       line(X(:,j),y,'color',[0 1 0])
    end
    axes(hw)
    cla
    view(2)
    grid off
    axis equal
    i=sqrt(-1);
    for kol=1:size(X,1)
       z=x+i*Y(kol,:);
       w=eval(fz);
       line(real(w),imag(w))
    end
    for row=1:size(X,2)
       z=X(:,row)+i*y';
       w=eval(fz);
       line(real(w),imag(w),'color',[0 1 0])
    end


case 'plot curve'
    
    hc=findobj(gcbf,'Tag','curvedef');
    z=get(hc,'String');
    dt=.001;
    t=0:dt:1;
    i=sqrt(-1);
    z=eval(z);
    h=findobj(gcbf,'Tag','z');
    axes(h)
    h=line(real(z),imag(z),'Color',[.5 0 .5],'Tag','curve','LineWidth',1.5);
    
    
case 'integrate'
    
    hc=findobj(gcbf,'Tag','curvedef');
    zc=get(hc,'String');
    dt=.001;
    t=dt/2:dt:1-dt/2;
    i=sqrt(-1);
    z=eval(zc);
    hf=findobj(gcbf,'Tag','f(z)');
    fz=get(hf,'String');
    f=eval(fz);
    t=0:dt:1;
    z=eval(zc);
    dz=diff(z);
    int=sum(f.*dz);
    hz=findobj(gcbf,'Tag','z');
    axes(hz)
    XLim=get(hz,'XLim');
    YLim=get(hz,'YLim');
    h=text(XLim(1)+.2*diff(XLim),YLim(1)+.2*diff(YLim),...
        ['\int f(z) dz = ' num2str(int)]);
    set(h,'FontSize',20,'Color',[.5 0 .5])
    pause(3)
    delete(h)
    h=findobj(gcbf,'Tag','curve');
    delete(h)
    
    
case 'BDF'

    cp=get(gca,'CurrentPoint');
    cp=cp(1,1:2);
    hz=findobj(gcbf,'Tag','z');
    axes(hz)
    XLim=get(hz,'XLim');
    YLim=get(hz,'YLim');
    x=cp(1);
    y=cp(2);
    hx=line(XLim,[y y],'color',[0 0 0],'Tag','x','LineWidth',2);
    hy=line([x x],YLim,'color',[0 0 0],'Tag','y','LineWidth',2);
    hw=findobj(gcbf,'Tag','w');
    axes(hw)
    grid off
    hf=findobj(gcbf,'Tag','f(z)');
    fz=get(hf,'String');
    i=sqrt(-1);
    z=[XLim(1):diff(XLim)/100:XLim(2)]+i*y;
    w=eval(fz);
    hx=line(real(w),imag(w),'color',[0 0 0],'Tag','wx','LineWidth',2);
    z=x+i*[YLim(1):diff(YLim)/100:YLim(2)];
    w=eval(fz);
    hy=line(real(w),imag(w),'color',[0 0 0],'Tag','wy','LineWidth',2);
    set(gcbf,'WindowButtonMotionFcn','COMPLEXadm(''WBMF'')')
    set(gcbf,'WindowButtonUpFcn','COMPLEXadm(''WBUF'')')
    set(gcbf,'DoubleBuffer','on')
    hl=findobj(gcbf,'Tag','linearization');
    val=get(hl,'Value');
    if val==1
        dx=diff(XLim)/20;
        dy=diff(YLim)/20;
        axes(hz)
        hold on
        h=fill([x x+dx x+dx x],[y y y+dy y+dy],[1 0 1]);
        hold off
        set(hz,'Tag','z')
        set(h,'Tag','z patch')
        
        axes(hw)
        z=cp(1)+i*cp(2);
        w0=eval(fz);
        Dfz=Df((fz),z);
        w=w0+Dfz.*[XLim(2)+i*y-z XLim(1)+i*y-z];
        hx=line(real(w),imag(w),'color',[1 0 1],'Tag','x:','LineWidth',2);
        w=w0+Dfz.*[x+i*YLim(2)-z x+i*YLim(1)-z];
        hy=line(real(w),imag(w),'color',[1 0 1],'Tag','y:','LineWidth',2);
        w=w0+Dfz.*([x x+dx x+dx x]+i*[y y y+dy y+dy]-z);
        hold on
        h=fill(real(w),imag(w),[1 0 1]);
        hold off
        set(hw,'Tag','w')
        set(h,'Tag','w patch')
        
    end
    
    
case 'linearization'

    hl=findobj(gcbf,'Tag','linearization');
    val=get(hl,'Value');
    if val==1
       set(hl,'String','linearization off')    
    elseif val==0
       set(hl,'String','linearization on')
   end
   
    
case 'WBMF'

    hz=findobj(gcbf,'Tag','z');
    axes(hz)
    cp=get(gca,'CurrentPoint');
    cp=cp(1,1:2); x=cp(1); y=cp(2);
    hx=findobj(gcbf,'Tag','x');
    hy=findobj(gcbf,'Tag','y');
    set(hx,'YData',[y y])
    set(hy,'XData',[x x])
    h=findobj(gcbf,'Tag','z');
    XLim=get(h,'XLim');
    YLim=get(h,'YLim');
    X=XLim(1):diff(XLim)/100:XLim(2);
    Y=YLim(1):diff(YLim)/100:YLim(2);
    hw=findobj(gcbf,'Tag','w');
    axes(hw)
    hf=findobj(gcbf,'Tag','f(z)');
    fz=get(hf,'String');
    i=sqrt(-1);
    z=X+i*y;
    w=eval(fz);
    hx=findobj(gcbf,'Tag','wx');
    set(hx,'XData',real(w),'YData',imag(w))
    z=x+i*Y;
    w=eval(fz);
    hy=findobj(gcbf,'Tag','wy');
    set(hy,'XData',real(w),'YData',imag(w))
    
    hl=findobj(gcbf,'Tag','linearization');
    val=get(hl,'Value');
    if val==1
        dx=diff(XLim)/20;
        dy=diff(YLim)/20;
        h=findobj(gcbf,'Tag','z patch');
        set(h,'XData',[x x+dx x+dx x],'YData',[y y y+dy y+dy])
        set(hz,'Tag','z')
        set(h,'Tag','z patch')
        hx=findobj(gcbf,'Tag','x:');
        set(hx,'XData',[x+dx x+dx],'YData',YLim)
        hy=findobj(gcbf,'Tag','y:');
        set(hy,'YData',[y+dy y+dy],'XData',XLim)
        
        axes(hw)
        z=cp(1)+i*cp(2);
        w0=eval(fz);
        Dfz=Df((fz),z);
        w=w0+Dfz.*[XLim(2)+i*y-z XLim(1)+i*y-z];
        hx=findobj(gcbf,'Tag','x:');
        set(hx,'XData',real(w),'YData',imag(w))
        w=w0+Dfz.*[x+i*YLim(2)-z x+i*YLim(1)-z];
        hy=findobj(gcbf,'Tag','y:');
        set(hy,'XData',real(w),'YData',imag(w))
        
        w=w0+Dfz.*([x x+dx x+dx x]+i*[y y y+dy y+dy]-z);
        h=findobj(gcbf,'Tag','w patch');
        set(h,'XData',real(w),'YData',imag(w))

    end

    

case 'WBUF'
    hx=findobj(gcbf,'Tag','x');
    delete(hx)
    hy=findobj(gcbf,'Tag','y');
    delete(hy)
    hx=findobj(gcbf,'Tag','wx');
    delete(hx)
    hy=findobj(gcbf,'Tag','wy');
    delete(hy)
    hp=findobj(gcbf,'Tag','z patch');
    delete(hp)
    hp=findobj(gcbf,'Tag','w patch');
    delete(hp)
    hx=findobj(gcbf,'Tag','x:');
    delete(hx)
    hy=findobj(gcbf,'Tag','y:');
    delete(hy)
    set(gcbf,'WindowButtonMotionFcn','')
    set(gcbf,'WindowButtonUpFcn','')

    
case 'change view'
    
    h=findobj(gcbf,'Tag','view');
    val=get(h,'Value');
    if val==1
       xlabel('Re w')
       ylabel('Im w')
       title('w = f(z) domain')
       COMPLEXadm('f(z)')
    else
       h=findobj(gcbf,'Tag','f(z)');
       fz=get(h,'String');
       hz=findobj(gcbf,'Tag','z');
       hw=findobj(gcbf,'Tag','w');
       XLim=get(hz,'XLim');
       YLim=get(hz,'YLim');
       x=XLim(1):diff(XLim)/20:XLim(2);
       y=YLim(1):diff(YLim)/20:YLim(2);
       [X,Y]=meshgrid(x,y);
       axes(hw)
       cla
       i=sqrt(-1);
       z=X+i*Y;
       w=eval(fz);
       if val==2
           surf(X,Y,real(w))
       elseif val==3
           surf(X,Y,imag(w))
       end
       set(gca,'Tag','w')
       h=findobj(gcbf,'Tag','view');
       val=get(h,'Value');
       if val>1
          xlabel('Re z')
          ylabel('Im z')
          title('u = Re w = Re f(z)')
       end
    end
    
    
case 'z zoom in'

    h = findobj(gcbf,'Tag','z');
    axes(h)
    XLim=get(h,'XLim');
    YLim=get(h,'YLim');
    set(h,'XLim',.5*XLim,'YLim',.5*YLim)
    xlabel('Re z')
    ylabel('Im z')
    title('z domain')
    COMPLEXadm('f(z)')
    
    
case 'z zoom out'
 
    h = findobj(gcbf,'Tag','z');
    axes(h)
    XLim=get(h,'XLim');
    YLim=get(h,'YLim');
    set(h,'XLim',2*XLim,'YLim',2*YLim)
    xlabel('Re z')
    ylabel('Im z')
    title('z domain')
    COMPLEXadm('f(z)')
    
    
case 'w zoom in'
    
    h = findobj(gcbf,'Tag','w');
    axes(h)
    XLim=get(h,'XLim');
    YLim=get(h,'YLim');
    set(h,'XLim',.5*XLim,'YLim',.5*YLim)
    xlabel('Re w')
    ylabel('Im w')
    title('w = f(z) domain')
    
    COMPLEXadm('f(z)')
    
    
case 'w zoom out'
    
    h = findobj(gcbf,'Tag','w');
    axes(h)
    XLim=get(h,'XLim');
    YLim=get(h,'YLim');
    set(h,'XLim',2*XLim,'YLim',2*YLim)
    xlabel('Re w')
    ylabel('Im w')
    title('w = f(z) domain')

    COMPLEXadm('f(z)')
    
    
end


function Dfz=Df(f,z)
    
    fz=eval(f);
    z=z+0.00000001;
    Dfz=(eval(f)-fz)/0.00000001;